<?php 

/*
 * add_value.php
 * Adds a value to an attribute for a given dn.
 * Variables that come in as POST vars:
 *  - dn (rawurlencoded)
 *  - attr (rawurlencoded) the attribute to which we are adding a value 
 *  - server_id
 *  - new_value (form element)
 *
 * On success, redirect to the edit_dn page.
 * On failure, echo an error.
 */

require 'config.php';
require_once 'functions.php';

$dn = stripslashes( rawurldecode( $_POST['dn'] ) );
$encoded_dn = rawurlencode( $dn );
$attr = stripslashes( $_POST['attr'] );
$encoded_attr = rawurlencode( $attr );
$server_id = $_POST['server_id'];
$new_value = stripslashes( $_POST['new_value'] );
$new_value = utf8_encode($new_value);

check_server_id( $server_id ) or die( "Bad server_id: " . htmlentities( $server_id ) );
have_auth_info( $server_id ) or die( "Not enough information to login to server. Please check your configuration." );

$ds = davedap_ldap_connect( $server_id ) or die( "Could not connect to LDAP server" );

$new_entry = array( $attr => $new_value );

$add_result = @ldap_mod_add( $ds, $dn, $new_entry );

if( ! $add_result )
{
	echo "Could not perform ldap_mod_add operation<br />";
	echo "LDAP said: " . ldap_error( $ds );
	exit;
}

header( "Location: edit.php?server_id=$server_id&dn=$encoded_dn&updated_attr=$encoded_attr" );

?>
