<?php 

/*
 * collapse.php
 * This script alters the session variable 'tree', collapsing it
 * at the dn specified in the query string. 
 *
 * Variables that come in as GET vars:
 *  - dn (rawurlencoded)
 *  - server_id
 *
 * Note: this script is equal and opposite to expand.php
 */

require 'config.php';
require_once 'functions.php';

$dn = stripslashes( $_GET['dn'] );
$encoded_dn = rawurlencode( $dn );
$server_id = $_GET['server_id'];

check_server_id( $server_id ) or die( "Bad server_id: " . htmlentities( $server_id ) );

session_start();
assert( session_is_registered( 'tree' ) );
$tree = $_SESSION['tree'];

// remove all the existing entries from the array as well
if( isset( $tree[$server_id][$dn] ) && is_array( $tree[$server_id][$dn] ) ) {
	foreach( $tree[$server_id][$dn] as $kill_dn ) 
		unset( $tree[$server_id][$kill_dn] );
}

// and remove this instance of the dn as well
unset( $tree[$server_id][$dn] );

$_SESSION['tree'] = $tree;
session_write_close();
header( "Location: tree.php#{$server_id}_{$encoded_dn}" );

; ?>
