<?php 

/*
 * create.php
 * Creates a new object.
 *
 * Variables that come in as POST vars:
 *  - new_dn
 *  - attrs (an array of attributes)
 *  - vals (an array of values for the above attrs)
 *  - required_attrs (an array with indices being the attributes,
 *		      and the values being their respective values)
 *  - server_id
 */

require 'config.php';
require_once 'functions.php';

$new_dn = stripslashes( $_POST['new_dn'] );
$new_dn = utf8_encode( $new_dn );
$new_rdn = stripslashes( $_POST['new_rdn'] );
$new_rdn = utf8_encode( $new_rdn );
$container = stripslashes( $_POST['container'] );
$encoded_dn = rawurlencode( $new_dn );
$server_id = $_POST['server_id'];
$vals = $_POST['vals'];
$attrs = $_POST['attrs'];
$required_attrs = $_POST['required_attrs'];
$object_classes = unserialize( rawurldecode( $_POST['object_classes'] ) );

check_server_id( $server_id ) or die( "Bad server_id: " . htmlentities( $server_id ) );
have_auth_info( $server_id ) or die( "Not enough information to login to server. Please check your configuration." );


// build the new entry
$new_entry = array();
foreach( $required_attrs as $attr => $val ) 
{

	if( ! $val )
	{
		echo "Error, you left the value for required attribute <b>" . htmlentities( $attr ) . "</b> blank.";
		exit;
	}

	$attr = stripslashes( $attr );
	$val  = stripslashes( $val );
	$new_entry[ $attr ][] = utf8_encode( $val );
}

foreach( $vals as $i => $val )
{
	$val = stripslashes( $val );
	$attr = $attrs[$i];
	$attr = stripslashes( $attr );
	if( trim($val) )
		$new_entry[ $attr ][] = utf8_encode( $val );
}

$new_entry['objectClass'] = $object_classes;
if( ! in_array( 'top', $new_entry['objectClass'] ) )
	$new_entry['objectClass'][] = 'top';

$ds = davedap_ldap_connect( $server_id );
$add_result = @ldap_add( $ds, $new_dn, $new_entry );
if( $add_result )
{
	$edit_url="edit.php?server_id=$server_id&dn=" . rawurlencode( $new_dn );

	// update the session tree to reflect the change
	session_start();
	if( session_is_registered( 'tree' ) )
	{
		$tree = $_SESSION['tree'];
		$tree[$server_id][$container][] = $new_dn;
		$_SESSION['tree'] = $tree;
		session_write_close();
	}

	?>
	<html>
	<head>
		<!-- refresh the tree view (with the new DN renamed)
		     and redirect to the edit_dn page -->
		<script language="javascript">
			parent.left_frame.location.reload();
		</script>

		<meta http-equiv="refresh" content="0; url=<?php echo $edit_url; ?>" />
	</head>
	<body>
	Redirecting... <a href="<?php echo $edit_url; ?>">here</a>.
	</body>
	</html>
	<?php 
}
else
{
	echo "Error: Could not add the object to the LDAP server.<br />";
	echo "LDAP said: " . ldap_error( $ds ) . "<br />";
	exit;
}

; ?>
