<?php 

/*
 * expand.php
 * This script alters the session variable 'tree', expanding it
 * at the dn specified in the query string. 
 *
 * Variables that come in as GET vars:
 *  - dn (rawurlencoded)
 *  - server_id
 *
 * Note: this script is equal and opposite to collapse.php
 */

require 'config.php';
require_once 'functions.php';

$dn = stripslashes( $_GET['dn'] );
$encoded_dn = rawurlencode( $dn );
$server_id = $_GET['server_id'];

check_server_id( $server_id ) or die( "Bad server_id: " . htmlentities( $server_id ) );
have_auth_info( $server_id ) or die( "Not enough information to login to server. Please check your configuration." );

session_start();
assert( isset( $servers[$server_id] ) );
assert( session_is_registered( 'tree' ) );
$tree = $_SESSION['tree'];

davedap_ldap_connect( $server_id ) or die( "Could not connect to LDAP server" );
$contents = get_container_contents( $server_id, $dn );

sort( $contents );
$tree[$server_id][$dn] = $contents;

$_SESSION['tree'] = $tree;
session_write_close();
header( "Location: tree.php#{$server_id}_{$encoded_dn}" );

; ?>
