<?php 

/*
 * refresh.php
 * This script alters the session variable 'tree', by re-querying
 * the LDAP server to grab the contents of every expanded container.
 *
 * Variables that come in as GET vars:
 *  - server_id
 */

require 'config.php';
require_once 'functions.php';

$server_id = $_GET['server_id'];

if( ! check_server_id( $server_id ) || ! have_auth_info( $server_id ) )
	header( "Location: tree.php" );

session_start();
if( ! session_is_registered( 'tree' ) )
	header( "Location: tree.php" );

$tree = $_SESSION['tree'];
foreach( $tree[$server_id] as $dn => $children )
{
	$tree[$server_id][$dn] = get_container_contents( $server_id, $dn );
	sort( $tree[ $server_id ][ $dn ] );
}
$_SESSION['tree'] = $tree;
session_write_close();

header( "Location: tree.php#$server_id" );


?>
